function [m1,m2,v1,v2,p1,p2]=TvcSpecDensIrf(theta1,theta2,R,p,n,c,points);

% initializing the fourier frequencies
freq=0:pi/points:pi;

for ii=1:size(theta1,2)
    A1 = companion(theta1(:,ii),p,n,c);
    A2 = companion(theta2(:,ii),p,n,c);
    B=zeros(size(A1,1),size(A1,1));
    B(1:n,1:n) = R(:,:,ii);
    v1(:,:,ii)=doublej(A1,B);
    v2(:,:,ii)=doublej(A2,B);
    ma1=inv(eye(size(A1,1))-A1);
    ma2=inv(eye(size(A2,1))-A2);
    m1(:,ii)=ma1(1:n,1:n)*theta1(1:n*p+c:end,ii);
    m2(:,ii)=ma2(1:n,1:n)*theta2(1:n*p+c:end,ii);
    for j = 1:length(freq),
        TR1 = inv(eye(size(A1,1))-A1*exp(-i*freq(j)*j));
        TR2 = inv(eye(size(A2,1))-A2*exp(-i*freq(j)*j));
        sd1(:,:,j,ii) = real(TR1*B*TR1'/(2.0*pi));
        sd2(:,:,j,ii) = real(TR2*B*TR2'/(2.0*pi));
    end
end
v1=v1(1:n,1:n,:);
v2=v2(1:n,1:n,:);
sd1=sd1(1:n,1:n,:,:);
sd2=sd2(1:n,1:n,:,:);
p1=squeeze(sd1(1:n,1:n,1,:));
p2=squeeze(sd2(1:n,1:n,1,:));
